Subject: [p2p-sip] DNS for inter-domain? Yes; intra-domain? No

From: RADHIKA.R.ROY at saic.com (Roy, Radhika R.)
Date: Fri, 8 Dec 2006 11:43:49 -0500

To some extent just because it uses the multicast property, but is not good
enough in mobile ad hoc network.
 
The issue is similar the way OSPFv3 was not good enough for mobile ad hoc
environment where P2P properties are important (here is something missing:
peering in ad hoc environment and its impact on DNS or mDNS). Also, it is
for SIP: audio/video and other features are also required.
 
Let us stop here.
 
We will revisit this issue later.
 
Best regards,
Radhika

  _____  

From: David Barrett [mailto:dbarrett at quinthar.com]
Sent: Fri 12/8/2006 3:37 AM
To: 'Roy, Radhika R.'; 'Eunsoo Shim'
Cc: 'P2P-SIP'
Subject: RE: [p2p-sip] DNS for inter-domain? Yes; intra-domain? No

I'm not sure I follow you here.

The "m" in "mDNS" stands for multicast because you send your DNS requests to
a multicast channel instead of to a fixed DNS server.  Anyone who knows the
answer broadcasts a reply.  It's designed precisely for an ad hoc network
with no fixed nodes.

Does this address your concern?

-david

> -----Original Message-----
> From: Roy, Radhika R. [mailto:RADHIKA.R.ROY at saic.com
<mailto:RADHIKA.R.ROY at saic.com> ]
> Sent: Thursday, December 07, 2006 8:51 PM
> To: David Barrett; Eunsoo Shim
> Cc: P2P-SIP
> Subject: RE: [p2p-sip] DNS for inter-domain? Yes; intra-domain? No
>
> Issue is this: Mobile ad hoc network - no fixed infrastructure where
> everything is P2P. No one knows who will be the next peer after a certain
> period of time. The speed of each peer may vary.
>
> DNS is used assuming that there is at least one fixed non-mobile node. It
> is
> the problem that we want to get rid of.
>
> First, let us understand what works in this environment.
>
> IETF MANET WG has all the drafts and RFCs.
>
> Best regards,
> Radhika
>
> PS:
>
> 1. It is not about DNS or mDNS or multicasting per se.
> 2. Let us find our what works in the above environment, i.e., MANET.
> Everything is distributive as P2P in mobile ad hoc environment. Period.
> 3. The routing protocol for MANET that will be used in the about
> environment
> best commercially (to be accepted as standard soon as all alternative
> protocols have provided their performance and simulations results, but
> this
> is expected to be chosen as s finalist - draft is available in the IETF
> MANET WG Archive): OSPFv3-MDR.
> 4. We may have to enhance the charter for the P2P-SIP in the future as the
> present scope of this would be WG is not enough. However, it is a
> different
> story as a first step let us accomplish what is in the present charter.
>
>
>
>
>   _____
>
> From: David Barrett [mailto:dbarrett at quinthar.com
<mailto:dbarrett at quinthar.com> ]
> Sent: Thu 12/7/2006 8:23 PM
> To: 'Roy, Radhika R.'; 'Eunsoo Shim'
> Cc: 'P2P-SIP'
> Subject: RE: [p2p-sip] DNS for inter-domain? Yes; intra-domain? No
>
>
>
> I'm not very familiar with MANET, but I think it supports multicast, so
> mDNS
> could probably play a role in it.
>
>
>
> Either way, if someone goes to the trouble of setting up some kind of
> grid/mesh network, they'll probably want to do more than just VoIP.
> They'll
> need *some* kind of DNS to use for everything else.  It's probable they'll
> find a way to tunnel normal DNS.  It's possible they'll find a way to use
> normal mDNS.  Before inventing a custom, non-DNS solution, it seems
> sensible
> to see how they're going to solve the DNS problem first and put our weight
> behind that, rather than inventing a new, competing solution.
>
>
>
> -david
>
>
>
> PS: What is inadequate about DNS and mDNS for your network today?
>
>
>
>   _____
>
> From: Roy, Radhika R. [mailto:RADHIKA.R.ROY at saic.com
<mailto:RADHIKA.R.ROY at saic.com> ]
> Sent: Thursday, December 07, 2006 2:45 PM
> To: David Barrett; Eunsoo Shim
> Cc: P2P-SIP
> Subject: RE: [p2p-sip] DNS for inter-domain? Yes; intra-domain? No
>
>
>
> David:
>
>
>
> Do DNS and mDNS also cover P2P Mobile Ad Hoc Networks (MANET)?
>
>
>
> We are looking for MANET support right now for P2P-SIP networking.
>
>
>
> Best regards,
>
> Radhika
>
>
>
> PS: We are using DNS right now, but no insufficient.
>
>
>
>   _____
>
> From: p2p-sip-bounces at cs.columbia.edu on behalf of David Barrett
> Sent: Thu 12/7/2006 4:37 PM
> To: 'Eunsoo Shim'
> Cc: 'P2P-SIP'
> Subject: Re: [p2p-sip] DNS for inter-domain? Yes; intra-domain? No
>
> Hm, I will agree that the conversation has covered all the useful ground
> it's going to cover.  As for the confusions you raise:
>
>
>
> -          DNS is used when available (internet or private network), and
> mDNS otherwise (ad hoc subnet)
>
> -          Multicast only works on subnets.  Ad hoc networks are typically
> single-subnets.  Thus mDNS works on ad hoc networks.
>
> -          Multicast does not work between subnets.  The internet and
> private networks use multiple subnets.  Thus mDNS will not work across the
> internet or on private networks spanning multiple subnets.  However, DNS
> is
> typically available in this case, and thus DNS is used instead.
>
> -          DNS and mDNS cover the total range of real-world networking
> environments.
>
> -          I understand P2P-SIP is currently proposed to use DNS as an
> optional extension to the mandatory DHT.  I think it'd be more sensible to
> have mandatory support for DNS with optional DHT, particularly because the
> DHT is hard work for no real-world gain and it seems wasteful to force
> everyone to pay it.
>
> -          The "P2P" system I propose as a replacement for DHT is merely
> what Adam originally proposed: configure P2P-SIP UAs to update a DNS
> record
> that points to another P2P-SIP UA as a proxy.
>
> -          Whether or not that is P2P "enough" is a long boring religious
> discussion.  But so far as we've been able to determine, this solves all
> the
> same use cases as the DHT, but with less work and better integration with
> existing SIP.
>
> -          P2P works; it's what pays my bills.  But it's a question of
> when
> and where is appropriate.
>
> Please let me know if you have any more questions about this idea or need
> me
> to clarify it more, but I think we've covered it exhaustively.
>
>
>
> -david
>
>
>
>   _____
>
> From: Eunsoo Shim [mailto:eunsooshim at gmail.com
<mailto:eunsooshim at gmail.com> ]
> Sent: Thursday, December 07, 2006 4:12 AM
> To: David Barrett
> Cc: Peter Pan; Henning Schulzrinne; P2P-SIP
> Subject: Re: [p2p-sip] DNS for inter-domain? Yes; intra-domain? No
>
>
>
> mDNS works only in a subnet. If you limit P2PSIP applications only to that
> environment, mDNS should work. You can go to SIPPING to talk about it.
> Many
> of us understand it.
> If you suggest mDNS even for other environments, please have the Internet
> changed to support multicast almost everywhere first. Then we can talk
> about
> using mDNS for P2PSIP in a general sense.
>
> dynDNS is just another DNS system, i.e. relying on DNS SERVERs. Using
> dynDNS
> is same as retrieving a redirect server information from DNS and getting
> the
> location of a particular user from the redirect server. That means, even
> we
> don't have to update the DNS infrastructure! Just use existing DNS and SIP
> and you can get what you propose.
>
> You continuously try to imply that P2PSIP does not use DNS at all. I
> pointed
> out that DNS was assumed for inter-domain connections for P2PSIP (and
> actually SIP). All left from your argument is that we got to use DNS
> servers
> even for intra-domain lookups, which is equivalent to using a central
> location server.
>
> Now it sounds to me that you are saying "p2p does not work. Stick to
> central
> servers!"
> I have no interest in arguing whether C/S architecture or P2P architecture
> is better. Neither are many people in this list, I believe. We understand
> there are tradeoffs. Maybe you can enjoy that kind of discussion with
> people
> from Skype or eDonkey.
>
> I think we passed already time for that kind of discussion here.
>
> Already the current SIP systems use central servers for location
> registration and voicemail storage.
> If you are interested in another way/protocol of using central servers for
> SIP, this is not a right place to propose it.
> If you have a problem with DHT, please propose a different 'P2P' mechanism
> for 'P2PSIP'.
>
>
> Thanks.
>
> Eunsoo
>
>
>
>
> On 12/6/06, David Barrett <dbarrett at quinthar.com
> <mailto:dbarrett at quinthar.com <mailto:dbarrett at quinthar.com> > > wrote:
>
> I'm not sure the DNS infrastructure needs much updating at all.  Perhaps
> there will be more demand for DNS registrars to offer automated (aka
> "dynamic") record updating, but that's really just standardizing what they
> already do.
>
>
>
> As for voicemail, no, I wouldn't expect to put that into DNS; that's
> something best handled by some real storage provider.  You *could* do it
> in
> a DHT, but it'd just be slower and less reliable, and the engineering cost
> of building that would pay for central storage many, many times over.
>
>
>
> Again, in a vacuum without taking anything else into consideration, be it
> engineering cost, performance, reliability, existing systems, standards
> support and so on, yes, a DHT could be used.  But when everything else is
> factored in, it just makes no sense at all.
>
>
>
> -david
>
>
>
>   _____
>
> From: Peter Pan [mailto:huang-ming.pan at comcast.net
<mailto:huang-ming.pan at comcast.net> 
> <mailto:huang-ming.pan at comcast.net <mailto:huang-ming.pan at comcast.net> > ]
> Sent: Wednesday, December 06, 2006 12:09 PM
> To: David Barrett; 'Henning Schulzrinne'
> Cc: 'P2P-SIP'
>
>
> Subject: Re: [p2p-sip] DNS for inter-domain? Yes; intra-domain? No
>
>
>
> Great summary. Please see my feedback inline.
>
>
>
> Peter
>
> ----- Original Message -----
>
> From: David Barrett <mailto:dbarrett at quinthar.com
<mailto:dbarrett at quinthar.com> >
>
> To: 'Henning Schulzrinne' <mailto:hgs at cs.columbia.edu
<mailto:hgs at cs.columbia.edu> >
>
> Cc: 'P2P-SIP' <mailto:p2p-sip at cs.columbia.edu
<mailto:p2p-sip at cs.columbia.edu> >
>
> Sent: Wednesday, December 06, 2006 12:07 AM
>
> Subject: Re: [p2p-sip] DNS for inter-domain? Yes; intra-domain? No
>
>
>
> I think the value of this discussion is in identifying and clarifying
> misimpressions about how DNS and mDNS work (and do not work) so we can
> make
> a more informed choice on whether or not to use them.  Already we've
> clarified:
>
>
>
> How can DNS records be automatically updated? (Through dynamic DNS
> protocols)
>
> - [pp]: what is the cost and feasibility to upgrade existing DNS
> infrastructure to support dynamic DNS globally? is it similiar to the
> deployment of ipv6 and ip mobility?
>
> - How fast can DNS propagate?  (Extremely fast with short TTLs)
>
> - What if I have multiple SIP proxies? (Put multiple IPs into the DNS
> record)
>
> Is DNS only for IP addresses? (No, can store other records)
>
> - [pp]: can/will these DNS server also store data like voicemail or other
> p2p application data?
>
> - How does DNS work in on ad-hoc networks? (Using mDNS via multicast)
>
> - Where is multicast supported? (Only everywhere it's needed - on subnets)
>
> - Is mDNS an IETF standard? (It's on the standards track.)
>
> - Is mDNS actually in use? (It's the foundation of zeroconf, which is used
> extensively by Apple)
>
> - Are there any use-cases that DHT supports that DNS/mDNS cannot?
> (Apparently not.)
>
>
>
> Lack of clarity on these points could call for the unnecessary dismissal
> of
> these technologies on false premises, which I think nobody wants.
>
>
>
> -david
>
>
>
>
>   _____
>
>
> From: Henning Schulzrinne [mailto:hgs at cs.columbia.edu
<mailto:hgs at cs.columbia.edu> 
> <mailto:hgs at cs.columbia.edu <mailto:hgs at cs.columbia.edu> > ]
> Sent: Tuesday, December 05, 2006 4:20 PM
> To: David Barrett
> Cc: 'Eunsoo Shim'; 'P2P-SIP'
> Subject: Re: [p2p-sip] DNS for inter-domain? Yes; intra-domain? No
>
>
>
> I have to admit that I'm confused by this whole discussion. I thought we
> had
> agreement that
>
>
>
> (1) specifying mDNS + SIP operation is useful (and hopefully simple), but
> easily handled within the framework of SIPPING;
>
>
>
> (2) specifying dynamic DNS + SIP might be useful, subject to working out
> issues such as proxy discovery, authentication and the like and that
> interested parties should work out, at least to the extent of identifying
> the pieces that might need work (as a random example: can I expect my SIP
> Digest secret to work as a DNS update secret?). If, as claimed, this is
> easy
> to do, SIPPING is again the natural home for such a BCP effort, with the
> DNS-related WGs as the home for any DNS extensions that might prove
> necessary.
>
>
>
> Maybe those individuals interested in solving (2) should form an informal
> design team and get beyond the hand-waving stage and identify the
> problems,
> if any, that would have to be addressed in either protocol or operational
> standards. I have unfortunately seen little such effort so far, although I
> suspect that such level of detail isn't terribly well suited to be hashed
> out in front of several hundred mailing list members.
>
>
>
>
>
> We also have had 2 BOFs and numerous ad-hoc meetings on this topic, with a
> rough consensus on the current charter. Are you trying to keep people from
> working on a specific topic you consider inferior?
>
>
>
> We seem to be rehashing the same arguments again and again.
>
>
>
> Henning
>
>
>
>
>
>
>
> On Dec 5, 2006, at 7:02 PM, David Barrett wrote:
>
>
>
> Does the actual, real-world availability of multicast factor into the
> decision as to whether or not to use it?
>
>
>
> I mean, we *could* assume that every odd IP address won't work, and then
> design around that.  But odd IP addresses *do* work.
>
>
>
> Likewise, multicast *is* (or could easily be made) available for all of
> the
> real-world use cases that demand it.
>
>
>
> It just seems like there are much more interesting *actual* problems to
> solve than those that don't affect real users.  But if you're excited
> about
> solving the non-multicast ad-hoc P2P-SIP problem on the assumption that
> someday, somebody will have reason to use it (even though we can't really
> brainstorm anybody who would use it today), then I guess that's a cool
> research project.
>
>
>
> But it's a *research* project, not an IETF standardization exercise.  DNS
> and mDNS work everywhere the *actual* users are, and thus I think the IETF
> should focus on them, first.
>
>
>
> -david
>
>
>
>
>   _____
>
>
> From: Eunsoo Shim [ mailto:eunsooshim at gmail.com
<mailto:eunsooshim at gmail.com> 
> <mailto:eunsooshim at gmail.com <mailto:eunsooshim at gmail.com> > ]
> Sent: Tuesday, December 05, 2006 3:04 PM
> To: David Barrett
> Cc: P2P-SIP
> Subject: Re: [p2p-sip] DNS for inter-domain? Yes; intra-domain? No
>
>
>
> I understand that mDNS can be used in ad-hoc networks where multicast
> works.
> Some of us, including me, have discussed about using mDNS and noticed that
> there is little to do to use mDNS or any other multicast-based discovery
> protocol.
> Those people decided not to focus on the approach because assuming
> multicast
> availability was not general and they did not want to limit P2PSIP into
> such
> network environments.
> They said such an approach (using mDNS or similar ones) could be discussed
> maybe in SIPPING.
>
> The proposed charter is targeting to address intra-domain lookup that
> works
> even if there is no multicast support.
>
> Using DNS for intra-domain lookup is not different from using a central
> server, which is not interesting to many of us, I believe. So transition
> from mDNS to DNS is not appealing, either.
>
> What do you say?
> Thanks.
>
> Eunsoo
>
> On 12/5/06, David Barrett <dbarrett at quinthar.com
> <mailto:dbarrett at quinthar.com <mailto:dbarrett at quinthar.com> > > wrote:
>
>
>
>
>   _____
>
>
> From: Eunsoo Shim
> Subject: [p2p-sip] DNS for inter-domain? Yes; intra-domain? No
>
>
>
> So my understanding is that what P2PSIP group is trying to do is designing
> mechanisms for P2P-style intra-domain location lookup where location
> records
> are distributed among peers rather than in a central location server.
>
> ...
>
> Am I missing any important aspect?
>
> I agree, this is what P2P-SIP is trying to do.  I'm just not certain why,
> because mDNS can do the same thing in a way that is already standardized,
> already deployed, and already works.  Basically, for every real-world
> case,
> it seems mDNS is adequate for ad-hoc unauthenticated namespaces, and DNS
> is
> adequate for global, authenticated namespaces.  There is already a
> seamless
> interface to graduate from mDNS to DNS depending upon what is available;
> it
> already covers the whole range of use cases (minus the extreme security
> cases, which I believe remain unsolved problems by any means).
>
>
>
> I don't dispute you could make a DHT bootstrapped with UPnP or whatever.
> You can build a lot of things.  I just don't see why we should bother when
> there are easier, adequate technologies available.
>
>
>
> -david
>
>
>
> _______________________________________________
>
> p2p-sip mailing list
>
> p2p-sip at cs.columbia.edu <mailto:p2p-sip at cs.columbia.edu
<mailto:p2p-sip at cs.columbia.edu> >
>
> https://lists.cs.columbia.edu/cucslists/listinfo/p2p-sip
<https://lists.cs.columbia.edu/cucslists/listinfo/p2p-sip> 
> <https://lists.cs.columbia.edu/cucslists/listinfo/p2p-sip
<https://lists.cs.columbia.edu/cucslists/listinfo/p2p-sip> >
>
>
>
>
>   _____
>
>
> _______________________________________________
> p2p-sip mailing list
> p2p-sip at cs.columbia.edu <mailto:p2p-sip at cs.columbia.edu
<mailto:p2p-sip at cs.columbia.edu> >
> https://lists.cs.columbia.edu/cucslists/listinfo/p2p-sip
<https://lists.cs.columbia.edu/cucslists/listinfo/p2p-sip> 
> <https://lists.cs.columbia.edu/cucslists/listinfo/p2p-sip
<https://lists.cs.columbia.edu/cucslists/listinfo/p2p-sip> >
>
>
> _______________________________________________
> p2p-sip mailing list
> p2p-sip at cs.columbia.edu <mailto:p2p-sip at cs.columbia.edu
<mailto:p2p-sip at cs.columbia.edu> >
> https://lists.cs.columbia.edu/cucslists/listinfo/p2p-sip
<https://lists.cs.columbia.edu/cucslists/listinfo/p2p-sip> 
> <https://lists.cs.columbia.edu/cucslists/listinfo/p2p-sip
<https://lists.cs.columbia.edu/cucslists/listinfo/p2p-sip> >